<?php
function dbConnect() {
    include 'php/db_settings.php';
    $db = new mysqli($DB_SERVER, $DB_USER, $DB_PASSWORD, $DB_NAME);
    if ($db->connect_errno) 
        die("Nepodarilo sa spojit s databazou.");
    $db->set_charset("utf8");
    return $db;
}

function logIn() {
    global $post;
    global $login_message;
    $login_message = "";
    $ok = true;
    if (!isset($post["name"]) || $post["name"]=="") {
        $login_message .= "Nevyplnili ste prihlasovacie meno.<br />";
        $ok = false;
    }
    if (!isset($post["password"]) || $post["password"]=="") {
        $login_message .= "Nevyplnili ste heslo.<br />";
        $ok = false;
    }
    if ($ok) {
        $db = dbConnect();
        $query = "select id, pass, salt from users where name = '".$db->real_escape_string(htmlspecialchars($post["name"]))."'";
        $result = $db->query($query);
        if ($result->num_rows==0) {
            $login_message = "Neznámy používateľ.";
        }
        else {
            $row = $result->fetch_object();
            if (md5($post["password"].$row->salt)==$row->pass) {
                $_SESSION["user"] = htmlspecialchars($post["name"]);
                $_SESSION["userid"] = $row->id;
            }
            else {
                $login_message = "Nesprávne heslo.";
            }
        }
    }
}

function signUp() {
    global $post;
    global $signup_message;
    $signup_message = "";
    $ok = true;
    if (!isset($post["signup_name"]) || $post["signup_name"]=="") {
        $signup_message .= "Nevyplnili ste prihlasovacie meno.<br />";
        $ok = false;
    }
    if (!isset($post["signup_password"]) || $post["signup_password"]=="") {
        $signup_message .= "Nevyplnili ste heslo.<br />";
        $ok = false;
    }
    elseif (!isset($post["password2"])) {
        $signup_message .= "Nevyplnili ste 2. heslo.<br />";
        $ok = false;
    }
    elseif ($post["signup_password"]!=$post["password2"]) {
        $signup_message .= "Zadané heslá sa nezhodujú.<br />";
        $ok = false;
    }
    
    if (!isset($post["firstname"]) || $post["firstname"]=="") {
        $signup_message .= "Nevyplnili ste krstné meno.<br />";
        $ok = false;
    }
    if (!isset($post["lastname"]) || $post["lastname"]=="") {
        $signup_message .= "Nevyplnili ste priezvisko.<br />";
        $ok = false;
    }
    if (!isset($post["school"]) || $post["school"]=="") {
        $signup_message .= "Nevyplnili ste školu.<br />";
        $ok = false;
    }
    if ($ok) {
        $db = dbConnect();
        $query = "select id from users where name = '".$db->real_escape_string(htmlspecialchars($post["signup_name"]))."'";
        if ($db->query($query)->num_rows) {
            $signup_message = "Uživateľ so zadaným prihlasovacím menom už existuje.";
            $post["signup_name"] = "";
        }
        else {
            $salt = rand(10000000, 99999999)."";
            $query = "insert into users values (null,'"
                    .$db->real_escape_string(htmlspecialchars($post["signup_name"]))."','"
                    .md5($post["signup_password"].$salt)."','"
                    .$salt."','"
                    .$db->real_escape_string(htmlspecialchars($post["firstname"]))."','"
                    .$db->real_escape_string(htmlspecialchars($post["lastname"]))."','"
                    .$db->real_escape_string(htmlspecialchars($post["school"]))
                    ."')";
            if ($db->query($query)) {
                $_SESSION["user"] = htmlspecialchars($post["signup_name"]);
                $_SESSION["userid"] = $db->insert_id;
                $query = "insert into data values (".$db->insert_id.",-1,0,-1,0,-1,1,-1,-1,-1,0,0,0,0,'','')";
                if (!$db->query($query)) {
                    $query = "delete from users where id = ".$_SESSION["userid"];
                    $db->query($query);
                    $signup_message = "Nastala chyba pri pridávaní do databázy. Skúste nabudúce.";
                    session_unset();
                }
            }
            else {
                $signup_message = "Nastala chyba pri pridávaní do databázy. Skúste nabudúce.";
            }
        }
    }
}
?>
