var odpovede;
var genPismena;
var size;
var letters_img;
var loading=0;
var pozicieX;
var pozicieY;
var klik = false;
var tahanie = -1;
var xx;
var yy;
var rozdielX;
var vowels;
var consonants;
var read = Array();
var check = false;
var wordCount = 0;

$("document").ready(function(){
    size = Math.min($(document).height()*0.55,$(document).width()*0.44/1.5);
    if($("#reading_canvas").attr("class")=="lvl1"){
        $("#reading_canvas").attr("width",1.5*size).attr("height",size);
        g = document.getElementById("reading_canvas").getContext("2d");
        $("#letters_check").css("font-size", $("#letters_check").height()/1.2+"px");
        genPismena = Array();
        pozicieX = Array();
        pozicieY = Array();
        for(var i = 0; i<26; i++){
            genPismena[i] = false;
        }
        odpovede = Array();
        for(var i = 0; i<4; i++){
            odpovede[i]=-1;
        }
        generuj();
        letters_img = Array();
        for(var i = 0; i<26; i++){
            letters_img[i] = new Image();
            letters_img[i].onload = nacitavanie;
            letters_img[i].src = "resources/images/abeceda/"+String.fromCharCode(i+97)+".jpg";
        }
        
    $("#reading_canvas").mousedown(function(e){
        for(i=0;i<4;i++){
            if((e.offsetX>pozicieX[i])&&(e.offsetX<pozicieX[i]+size/4)&&(e.offsetY>pozicieY[i]-size/11)&&(e.offsetY<pozicieY[i])){
                klik=true;
                tahanie=i;
                xx = e.offsetX;
                yy = e.offsetY;
                //console.log(xx);
            }
        }   
    });
    
    $("#reading_canvas").mousemove(function(e){
        if(klik){
            //rozdielX = ;
            pozicieX[tahanie]+=e.offsetX-xx;
            pozicieY[tahanie]+=(e.offsetY-yy);
            xx = e.offsetX;
            yy = e.offsetY;
            vykresliPisane();
//            console.log(rozdielX);
        }
    });
    
    $("#success").mousedown(function(e){
         $("#success").css("display", "none");
         console.log("kvik");
         for(var i = 0; i<26; i++){
            genPismena[i] = false;
         }
         for(var i = 0; i<4; i++){
            odpovede[i]=-1;
         }
         generuj();
         vykresliPisane();
    });
    
    $("#unsuccess").mousedown(function(e){
         $("#unsuccess").css("display", "none");
    });
    
    $("#reading_canvas").mouseup(function(e){
        klik = false;
        tahanie = -1;
    });
    
    $("#letters_check").click(function(e){
        check = true;
        for (i = 0; i<4; i++){
            if(!((pozicieX[i]>size/3)&&(pozicieX[i]<size/3+size/1.3-size/2.6)&&(pozicieY[i]>i*size/4+size/7)&&(pozicieY[i]<(i+1)*size/4))){
                check = false;
            }
        }
        if(check){
            $("#success").css("display", "block");
        } else $("#unsuccess").css("display", "block");
    });
    
      
//
    } else 
    {
        if($("#slabika1").size()){
            vowels = samohlasky.split(",");
            consonants = spoluhlasky.split(",");
            $("#slabika1").css({
                "font-size": $("#slabika1").height()/1.4+"px",
                "top":  $("#main_letters").innerHeight()/2-$("#slabika1").outerHeight()/2+"px",
                "left":  $("#main_letters").innerWidth()/2-$("#slabika1").outerWidth()/2+"px"
            }).click(generujSlabiky);
            
            var div = $("#slabika1").get(0);
            div.onselectstart = function() {return false;};
            generujSlabiky();
            $(document).keydown(function(e) {
                switch (e.keyCode) {
                    case 13: case 39:
                        generujSlabiky();
                        break;
                }
            });
            

        }

        if ($("#slovo").size()) {
            $("#slovo").css("display", "block");
            nextWord();


            $("#slovo").mousedown(nextWord);
            $("#slovo").css({
                "top":  $("#main_letters").innerHeight()/2-$("#slovo").outerHeight()/2+"px",
                "left":  $("#main_letters").innerWidth()/2-$("#slovo").outerWidth()/2+"px",
                "font-size": $("#slovo").innerHeight()/1.5+"px"
            }).each(function() {
                this.onselectstart = function() {return false;};
            });
        }
    }
});

function nextWord() {
    wordCount++;
    if (wordCount<=words.length) {
        var i;
        do {
            i = Math.floor(Math.random()*(words.length-0.01));
        } while (words[i][1]);
        $("#slovo").html(words[i][0]);
        words[i][1] = true;
    } else $("#slovo").html("–");
}

function generujSlabiky(){
//        $("#slabika"+i).html(i);
        $("#slabika1").html(consonants[Math.floor(Math.random()*(consonants.length-0.01))]+vowels[Math.floor(Math.random()*(vowels.length-0.01))]);
}

function nacitavanie(){
    if(++loading==26){
        vykresliPisane();
    }
}

function generuj(){
    help = -1;
    for(var i = 0; i<4; i++){
        do{
            help = Math.floor(Math.random()*25.99);
        }while (genPismena[help]==true);
        genPismena[help] = true;
        
        
        do{
            help = Math.floor(Math.random()*3.99);
        }while (odpovede[help]!=-1);
        odpovede[help]=i;
        
        pozicieX[help]=size-size/7;
        pozicieY[help]=odpovede[help]*size/4+size/7;
//        console.log(help);
    }
//    for(i=0;i<4;i++){
//        console.log(odpovede[i]);
//    }
//    for(var i = 0; i<26; i++){
//        console.log(genPismena[i]+", ");
//    }
}

function VykresliMriezku(){
    g.strokeStyle = "blue";
    g.lineCap = "round";
    g.lineWidth = 10;
    g.beginPath();
    g.moveTo(5,5);
    g.lineTo(size/1.3,5);
    g.stroke();
    g.moveTo(size/1.3,5);
    g.lineTo(size/1.3,size-5);
    g.stroke();
    g.moveTo(size/1.3,size-5);
    g.lineTo(0+5,size-5);
    g.stroke();
    g.moveTo(0+5,size-5);
    g.lineTo(5,5);
    g.stroke();
    g.moveTo(size/3,0);
    g.lineTo(size/3,size);
    g.stroke();
    for(var i = 1;i<4; i++){
        g.moveTo(0,i*size/4);
        g.lineTo(size/1.3,i*size/4);
        g.stroke();
    }
    g.closePath();
}

function vykresliPisane(){
    g.clearRect(0, 0, size*1.5, size);
    help = 0;
    for(var i = 0; i<26; i++){
        if(genPismena[i]==true){
            g.drawImage(letters_img[i],15, help*size/4+10, size/3.5, size/5);
            help++;
        }
    }
    
    VykresliMriezku();
    VykresliTlacene();
}

function VykresliTlacene(){
    g.font = "bold "+size/7+"px verdana";
    help = 0;
    for(i = 0; i<26; i++){
        if(genPismena[i]==true){
//            pozicieX[help]=400;
//            pozicieY[help]=odpovede[help]*size/4+size/7;
            g.fillText(String.fromCharCode(i+65)+" "+String.fromCharCode(i+97), pozicieX[help],  pozicieY[help]);
            help++;
        }
    }
}
